(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('@angular/forms'), require('@angular/core'), require('@angular/common'), require('@anjuna/core')) :
    typeof define === 'function' && define.amd ? define('@anjuna/angular-core', ['exports', 'rxjs', '@angular/forms', '@angular/core', '@angular/common', '@anjuna/core'], factory) :
    (factory((global.anjuna = global.anjuna || {}, global.anjuna['angular-core'] = {}),global.rxjs,global.ng.forms,global.ng.core,global.ng.common,global.core));
}(this, (function (exports,rxjs,forms,i0,common,core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var TENANT_TIMEZONE_STRING = new i0.InjectionToken('TenantTimezoneString');
    /** @type {?} */
    var TENANT_MERIDIEM = new i0.InjectionToken('TenantMeridiem');
    /** @type {?} */
    var TIMEZONE_OVERRIDE = new i0.InjectionToken('TimezoneOverride');
    /** @type {?} */
    var MOMENT = new i0.InjectionToken('MomentJs');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* Note: Typings of 'any' in this file refer to Moment.
             The Moment type does not come without the full weight of Moment.js, so it was intentionally left out. */
    var MomentDateAdapter = /** @class */ (function () {
        function MomentDateAdapter(_moment, _locale, _timezone) {
            this._moment = _moment;
            this._locale = _locale;
            this._timezone = _timezone;
            this.moment = _moment;
            this.timezone = _timezone;
            if (this.moment) {
                this.moment.locale(this._locale);
                if (this.timezone) {
                    this.moment.tz.setDefault(this.timezone);
                }
                else {
                    console.warn('Timezone is not set, is defaulting to system timezone. TIMEZONE_OVERRIDE may be set at the Module level.');
                }
            }
            else {
                console.error('Package "moment" has not been installed. Please either install "moment" or use the NativeDateAdapter.');
            }
        }
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        MomentDateAdapter.prototype.dayOfFirst = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                /** @type {?} */
                var adjusted = this.handleMonthAdjustment(year, month);
                return this.moment([adjusted.year, adjusted.month, 1]).day();
            };
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        MomentDateAdapter.prototype.daysInMonth = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                /** @type {?} */
                var adjusted = this.handleMonthAdjustment(year, month);
                return this.moment([adjusted.year, adjusted.month]).daysInMonth();
            };
        /**
         * @param {?} evalDate
         * @param {?} dateRangeParams
         * @return {?}
         */
        MomentDateAdapter.prototype.isDisabled = /**
         * @param {?} evalDate
         * @param {?} dateRangeParams
         * @return {?}
         */
            function (evalDate, dateRangeParams) {
                if (!dateRangeParams || (!dateRangeParams.minDate && !dateRangeParams.maxDate)) {
                    return false;
                }
                /** @type {?} */
                var dayIsBeforeMinDate = this.moment(evalDate).isBefore(this.moment(dateRangeParams.minDate), 'day');
                /** @type {?} */
                var dayIsAfterMaxDate = this.moment(evalDate).isAfter(this.moment(dateRangeParams.maxDate), 'day');
                return dayIsBeforeMinDate || dayIsAfterMaxDate;
            };
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        MomentDateAdapter.prototype.getMonthInfo = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                /** @type {?} */
                var adjusted = this.handleMonthAdjustment(year, month);
                return new Date(this.moment([adjusted.year, adjusted.month, 15]));
            };
        /**
         * @param {?} date
         * @return {?}
         */
        MomentDateAdapter.prototype.month = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return this.moment(date).month();
            };
        /**
         * @param {?=} year
         * @param {?=} month
         * @param {?=} day
         * @return {?}
         */
        MomentDateAdapter.prototype.newDateFromArray = /**
         * @param {?=} year
         * @param {?=} month
         * @param {?=} day
         * @return {?}
         */
            function (year, month, day) {
                if (month === void 0) {
                    month = 0;
                }
                if (day === void 0) {
                    day = 1;
                }
                return new Date(this.moment([year, month, day]));
            };
        /**
         * @param {?=} value
         * @return {?}
         */
        MomentDateAdapter.prototype.newDateFromValue = /**
         * @param {?=} value
         * @return {?}
         */
            function (value) {
                if (!value) {
                    return new Date();
                }
                else if (value instanceof Date) {
                    return new Date(this.moment(value));
                }
                else {
                    return new Date(value);
                }
            };
        /**
         * @param {?} date
         * @return {?}
         */
        MomentDateAdapter.prototype.prepHeaderDate = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return this.moment(date).locale(this.formatterLanguage || this._locale).format('ddd, MMM D');
            };
        /**
         * @param {?} date
         * @return {?}
         */
        MomentDateAdapter.prototype.prepHeaderYear = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return this.moment(date).locale(this.formatterLanguage || this._locale).format('YYYY');
            };
        /**
         * @param {?} _calendarDay
         * @param {?} _comparator
         * @return {?}
         */
        MomentDateAdapter.prototype.sameDay = /**
         * @param {?} _calendarDay
         * @param {?} _comparator
         * @return {?}
         */
            function (_calendarDay, _comparator) {
                /** @type {?} */
                var calendarDay = this.moment([_calendarDay.year, _calendarDay.month, _calendarDay.day]);
                /** @type {?} */
                var comparator = this.moment(_comparator);
                return calendarDay.isSame(comparator, 'day');
            };
        /**
         * @param {?} date
         * @return {?}
         */
        MomentDateAdapter.prototype.year = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return this.moment(date).year();
            };
        /**
         * @return {?}
         */
        MomentDateAdapter.prototype.weekdays = /**
         * @return {?}
         */
            function () {
                return this.moment.weekdays();
            };
        /**
         * @return {?}
         */
        MomentDateAdapter.prototype.months = /**
         * @return {?}
         */
            function () {
                return this.moment.monthsShort();
            };
        /**
         * @private
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        MomentDateAdapter.prototype.handleMonthAdjustment = /**
         * @private
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                if (month > 11) {
                    month = month - 12;
                    year++;
                }
                else if (month < 0) {
                    month = month + 12;
                    year--;
                }
                return { year: year, month: month };
            };
        /**
         * @param {?} input
         * @return {?}
         */
        MomentDateAdapter.prototype.prepDateStringOutput = /**
         * @param {?} input
         * @return {?}
         */
            function (input) {
                return (input) ? this.moment(this.processDateInput(input)).format('l') : '';
            };
        /**
         * @param {?} input
         * @return {?}
         */
        MomentDateAdapter.prototype.processDateInput = /**
         * @param {?} input
         * @return {?}
         */
            function (input) {
                if (!input) {
                    return null;
                }
                if (input && this.moment(input, 'L', this._locale).isValid()) {
                    /** @type {?} */
                    var timezone = this.timezone || this.moment.tz.guess();
                    return this.moment(input, 'L', this._locale).tz(timezone).startOf('day').toDate();
                }
                return new Date('false');
            };
        MomentDateAdapter.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        MomentDateAdapter.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: i0.Inject, args: [MOMENT,] }] },
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [i0.LOCALE_ID,] }] },
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [TIMEZONE_OVERRIDE,] }] }
            ];
        };
        return MomentDateAdapter;
    }());
    /**
     * @param {?} MOMENT_
     * @param {?=} locale
     * @param {?=} timezone
     * @return {?}
     */
    function getMomentDateAdapter(MOMENT_, locale, timezone) {
        return new MomentDateAdapter(MOMENT_, locale, timezone);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var STANDARD_LOCALES = {
        'en-US': 'M/d/yyyy',
        'sw-KE': 'M/d/yyyy',
        'en-ZW': 'M/d/yyyy',
        'en-PH': 'M/d/yyyy',
        'rw-RW': 'M/d/yyyy',
        'moh-CA': 'M/d/yyyy',
        'fil-PH': 'M/d/yyyy',
        'ne-NP': 'M/d/yyyy',
        'es-US': 'M/d/yyyy',
        'sq-AL': 'yyyy/M/d',
        'bg-BG': 'yyyy/M/d',
        'sr-BA': 'yyyy/M/d',
        'fr-CA': 'yyyy/M/d',
        'zh-CN': 'yyyy/M/d',
        'zh-HK': 'yyyy/M/d',
        'hu-HU': 'yyyy/M/d',
        'ja-JP': 'yyyy/M/d',
        'ko-KR': 'yyyy/M/d',
        'lt-LT': 'yyyy/M/d',
        'sv-SE': 'yyyy/M/d',
        'zh-TW': 'yyyy/M/d',
        'en-ZA': 'yyyy/M/d'
    };
    /**
     * @abstract
     * @template T
     */
    var /**
     * @abstract
     * @template T
     */ DateAdapter = /** @class */ (function () {
        function DateAdapter() {
        }
        return DateAdapter;
    }());
    // Default adapter, will accept String or Native Date
    var NativeDateAdapter = /** @class */ (function () {
        function NativeDateAdapter(_locale) {
            this._locale = _locale;
            this.languageCode = (_locale) ? _locale.split('-')[0] : 'en';
        }
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        NativeDateAdapter.prototype.dayOfFirst = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                return new Date(year, month, 1).getDay();
            };
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        NativeDateAdapter.prototype.daysInMonth = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                return new Date(year, month + 1, 0).getDate();
            };
        /**
         * @param {?} evalDate
         * @param {?} dateRangeParams
         * @return {?}
         */
        NativeDateAdapter.prototype.isDisabled = /**
         * @param {?} evalDate
         * @param {?} dateRangeParams
         * @return {?}
         */
            function (evalDate, dateRangeParams) {
                if (!dateRangeParams) {
                    return false;
                }
                /** @type {?} */
                var dayIsBeforeMinDate = (dateRangeParams.minDate) ? evalDate < dateRangeParams.minDate : false;
                /** @type {?} */
                var dayIsAfterMaxDate = (dateRangeParams.maxDate) ? evalDate > dateRangeParams.maxDate : false;
                return dayIsBeforeMinDate || dayIsAfterMaxDate;
            };
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        NativeDateAdapter.prototype.getMonthInfo = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                return new Date(year, month, 15);
            };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.month = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return date.getMonth();
            };
        /**
         * @param {?=} year
         * @param {?=} month
         * @param {?=} day
         * @return {?}
         */
        NativeDateAdapter.prototype.newDateFromArray = /**
         * @param {?=} year
         * @param {?=} month
         * @param {?=} day
         * @return {?}
         */
            function (year, month, day) {
                return new Date(year, month, day);
            };
        /**
         * @param {?=} value
         * @return {?}
         */
        NativeDateAdapter.prototype.newDateFromValue = /**
         * @param {?=} value
         * @return {?}
         */
            function (value) {
                return (value) ? new Date(value) : new Date();
            };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.prepHeaderDate = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return localize(this.languageCode, date, 'EEE, MMM d');
            };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.prepHeaderYear = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return localize(this.languageCode, date, 'yyyy');
            };
        /**
         * @param {?} _calendarDay
         * @param {?} _comparator
         * @return {?}
         */
        NativeDateAdapter.prototype.sameDay = /**
         * @param {?} _calendarDay
         * @param {?} _comparator
         * @return {?}
         */
            function (_calendarDay, _comparator) {
                return _calendarDay.day === _comparator.getDate()
                    && _calendarDay.month === _comparator.getMonth()
                    && _calendarDay.year === _comparator.getFullYear();
            };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.year = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return date.getFullYear();
            };
        /**
         * @return {?}
         */
        NativeDateAdapter.prototype.weekdays = /**
         * @return {?}
         */
            function () {
                return getWeekdays(this.languageCode);
            };
        /**
         * @return {?}
         */
        NativeDateAdapter.prototype.months = /**
         * @return {?}
         */
            function () {
                return getMonths(this.languageCode);
            };
        /**
         * @param {?} input
         * @return {?}
         */
        NativeDateAdapter.prototype.prepDateStringOutput = /**
         * @param {?} input
         * @return {?}
         */
            function (input) {
                return (input) ? new Date(this.processDateInput(input)).toLocaleDateString(this._locale) : '';
            };
        /**
         * @param {?} input
         * @return {?}
         */
        NativeDateAdapter.prototype.processDateInput = /**
         * @param {?} input
         * @return {?}
         */
            function (input) {
                if (!input) {
                    return null;
                }
                if (typeof input === 'string') {
                    /** @type {?} */
                    var dateSegments = parseInput(input, this._locale);
                    if (Array.isArray(dateSegments.splitDate) && dateSegments.splitDate.length === 3 && dateSegments.year) {
                        return new Date(parseInt(dateSegments.year, 10), parseInt(dateSegments.month, 10) - 1, parseInt(dateSegments.day, 10));
                    }
                    else {
                        return new Date(input);
                    }
                }
                else {
                    return input;
                }
            };
        /** @nocollapse */
        NativeDateAdapter.ctorParameters = function () {
            return [
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [i0.LOCALE_ID,] }] }
            ];
        };
        return NativeDateAdapter;
    }());
    /**
     * @param {?} lang
     * @return {?}
     */
    function getWeekdays(lang) {
        /** @type {?} */
        var weekdays = [];
        for (var i = 0; i < 7; i++) {
            /** @type {?} */
            var date = new Date();
            /** @type {?} */
            var testDate = date.setDate(date.getDate() - date.getDay() + i);
            weekdays.push(localize(lang, new Date(testDate), 'EEE'));
        }
        return weekdays;
    }
    /**
     * @param {?} lang
     * @return {?}
     */
    function getMonths(lang) {
        /** @type {?} */
        var months = [];
        for (var i = 0; i < 12; i++) {
            /** @type {?} */
            var testDate = new Date().setMonth(i);
            months.push(localize(lang, new Date(testDate), 'MMM'));
        }
        return months;
    }
    /**
     * @param {?=} _languageCode
     * @param {?=} date
     * @param {?=} format
     * @return {?}
     */
    function localize(_languageCode, date, format) {
        if (_languageCode === void 0) {
            _languageCode = 'en';
        }
        /** @type {?} */
        var pipe = new common.DatePipe(_languageCode);
        return pipe.transform(date, format);
    }
    /* Currently only support shortDate strings (with non-alphanumeric separators) of:
        {
            Month-Day-Year: if included in STANDARD_LOCALES,
            Year-Month-Day: if included in STANDARD_LOCALES,
            Day-Month-Year: for all locales outside of STANDARD_LOCALES
        }
     */
    /**
     * @param {?} input
     * @param {?} locale
     * @return {?}
     */
    function parseInput(input, locale) {
        /** @type {?} */
        var format = STANDARD_LOCALES[locale];
        // Covers case of partial locale code provided
        if (!format) {
            /** @type {?} */
            var localeKey = Object.keys(STANDARD_LOCALES).find(function (key) { return key.includes(locale); });
            format = STANDARD_LOCALES[localeKey];
        }
        // Split string on any non-alphanumeric characters, not including spaces
        /** @type {?} */
        var regexSplit = input.split(/[^\w\s]+/g).filter(Boolean);
        // Parse digit-only string, or use the regexSplit value
        /** @type {?} */
        var splitDate = (regexSplit.length <= 1 && input.length === 8) ? parseDigitOnlyDate(input, format) : regexSplit;
        /** @type {?} */
        var dateSegments = {
            splitDate: splitDate,
            year: '',
            month: '',
            day: ''
        };
        /** @type {?} */
        var splitDateCp = splitDate.slice(0);
        // Set year
        dateSegments.year = setYearSegment(splitDateCp);
        // Set Day and Month
        Object.assign(dateSegments, setMonthAndDaySegments(splitDateCp, format));
        return dateSegments;
    }
    /**
     * @param {?} splitDateArray
     * @return {?}
     */
    function setYearSegment(splitDateArray) {
        // Find year
        /** @type {?} */
        var year = splitDateArray.find(function (segment) { return segment.length === 4; });
        // Remove year from working array
        /** @type {?} */
        var yearIndex = splitDateArray.indexOf(year);
        splitDateArray.splice(yearIndex, 1);
        return year;
    }
    /**
     * @param {?} splitDateArray
     * @param {?} format
     * @return {?}
     */
    function setMonthAndDaySegments(splitDateArray, format) {
        /** @type {?} */
        var segments = {
            day: '',
            month: ''
        };
        // See if we can determine which segment is the days segment
        /** @type {?} */
        var assumedDay = splitDateArray.find(function (segment) { return parseInt(segment, 10) > 12; });
        if (assumedDay) {
            segments.day = assumedDay;
            /** @type {?} */
            var dayIndex = splitDateArray.indexOf(assumedDay);
            splitDateArray.splice(dayIndex, 1);
            segments.month = splitDateArray[0];
            // Otherwise, make a reasonable guess
        }
        else {
            switch (format) {
                case 'M/d/yyyy':
                case 'yyyy/M/d':
                    segments.month = splitDateArray[0];
                    segments.day = splitDateArray[1];
                    break;
                // Assume 'dd/MM/yyyy' for anything else
                default:
                    segments.month = splitDateArray[1];
                    segments.day = splitDateArray[0];
                    break;
            }
        }
        return segments;
    }
    /**
     * @param {?} input
     * @param {?} format
     * @return {?}
     */
    function parseDigitOnlyDate(input, format) {
        /** @type {?} */
        var splitDate;
        switch (format) {
            case 'yyyy/M/d':
                splitDate = [
                    input.slice(0, 4),
                    input.slice(4, 6),
                    input.slice(6)
                ];
                break;
            // Assume 'dd/MM/yyyy' or 'M/d/yyyy' for anything else
            default:
                splitDate = [
                    input.slice(0, 2),
                    input.slice(2, 4),
                    input.slice(4)
                ];
                break;
        }
        return splitDate;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UTCDateAdapter = /** @class */ (function () {
        function UTCDateAdapter(_locale) {
            this._locale = _locale;
            this.languageCode = (_locale) ? _locale.split('-')[0] : 'en';
        }
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        UTCDateAdapter.prototype.dayOfFirst = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                return new Date(year, month, 1).getDay();
            };
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        UTCDateAdapter.prototype.daysInMonth = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                return new Date(year, month + 1, 0).getDate();
            };
        /**
         * @param {?} evalDate
         * @param {?} dateRangeParams
         * @return {?}
         */
        UTCDateAdapter.prototype.isDisabled = /**
         * @param {?} evalDate
         * @param {?} dateRangeParams
         * @return {?}
         */
            function (evalDate, dateRangeParams) {
                if (!dateRangeParams) {
                    return false;
                }
                /** @type {?} */
                var dayIsBeforeMinDate = (dateRangeParams.minDate) ? evalDate < dateRangeParams.minDate : false;
                /** @type {?} */
                var dayIsAfterMaxDate = (dateRangeParams.maxDate) ? evalDate > dateRangeParams.maxDate : false;
                return dayIsBeforeMinDate || dayIsAfterMaxDate;
            };
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        UTCDateAdapter.prototype.getMonthInfo = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                return new Date(year, month, 15);
            };
        /**
         * @param {?} date
         * @return {?}
         */
        UTCDateAdapter.prototype.month = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return date.getUTCMonth();
            };
        /**
         * @param {?=} year
         * @param {?=} month
         * @param {?=} day
         * @return {?}
         */
        UTCDateAdapter.prototype.newDateFromArray = /**
         * @param {?=} year
         * @param {?=} month
         * @param {?=} day
         * @return {?}
         */
            function (year, month, day) {
                return new Date(Date.UTC(year, month, day));
            };
        /**
         * @param {?=} value
         * @return {?}
         */
        UTCDateAdapter.prototype.newDateFromValue = /**
         * @param {?=} value
         * @return {?}
         */
            function (value) {
                return (value) ? this.processDateInput(value) : this.getZerodDate(new Date());
            };
        /**
         * @param {?} date
         * @return {?}
         */
        UTCDateAdapter.prototype.prepHeaderDate = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return localize(this.languageCode, this.addTimezoneOffset(date), 'EEE, MMM d');
            };
        /**
         * @param {?} date
         * @return {?}
         */
        UTCDateAdapter.prototype.prepHeaderYear = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return localize(this.languageCode, this.addTimezoneOffset(date), 'yyyy');
            };
        /**
         * @param {?} _calendarDay
         * @param {?} _comparator
         * @return {?}
         */
        UTCDateAdapter.prototype.sameDay = /**
         * @param {?} _calendarDay
         * @param {?} _comparator
         * @return {?}
         */
            function (_calendarDay, _comparator) {
                return _calendarDay.day === _comparator.getUTCDate()
                    && _calendarDay.month === _comparator.getUTCMonth()
                    && _calendarDay.year === _comparator.getUTCFullYear();
            };
        /**
         * @param {?} date
         * @return {?}
         */
        UTCDateAdapter.prototype.year = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return date.getUTCFullYear();
            };
        /**
         * @return {?}
         */
        UTCDateAdapter.prototype.weekdays = /**
         * @return {?}
         */
            function () {
                return getWeekdays(this.languageCode);
            };
        /**
         * @return {?}
         */
        UTCDateAdapter.prototype.months = /**
         * @return {?}
         */
            function () {
                return getMonths(this.languageCode);
            };
        /**
         * @param {?} input
         * @return {?}
         */
        UTCDateAdapter.prototype.prepDateStringOutput = /**
         * @param {?} input
         * @return {?}
         */
            function (input) {
                return (input) ? new Date(this.processDateInput(input)).toLocaleDateString(this._locale, { timeZone: 'UTC' }) : '';
            };
        /**
         * @param {?} input
         * @return {?}
         */
        UTCDateAdapter.prototype.processDateInput = /**
         * @param {?} input
         * @return {?}
         */
            function (input) {
                if (!input) {
                    return null;
                }
                if (typeof input === 'string') {
                    /** @type {?} */
                    var dateSegments = parseInput(input, this._locale);
                    if (Array.isArray(dateSegments.splitDate) && dateSegments.splitDate.length === 3 && dateSegments.year) {
                        return new Date(Date.UTC(parseInt(dateSegments.year, 10), parseInt(dateSegments.month, 10) - 1, parseInt(dateSegments.day, 10)));
                    }
                    else {
                        // This is a fallback for malformed date string, outcome unknown
                        return new Date(input);
                    }
                }
                else {
                    return this.getZerodDate(input);
                }
            };
        /**
         * @private
         * @param {?} date
         * @return {?}
         */
        UTCDateAdapter.prototype.addTimezoneOffset = /**
         * @private
         * @param {?} date
         * @return {?}
         */
            function (date) {
                /** @type {?} */
                var newDate = new Date(date);
                /** @type {?} */
                var timeOffsetInMS = date.getTimezoneOffset() * 60000;
                newDate.setTime(date.getTime() + timeOffsetInMS);
                return newDate;
            };
        /**
         * @private
         * @param {?} date
         * @return {?}
         */
        UTCDateAdapter.prototype.getZerodDate = /**
         * @private
         * @param {?} date
         * @return {?}
         */
            function (date) {
                /** @type {?} */
                var safeDate = (date._isAMomentObject) ? new Date(date) : date;
                /** @type {?} */
                var day = safeDate.getUTCDate();
                /** @type {?} */
                var month = safeDate.getUTCMonth();
                /** @type {?} */
                var year = safeDate.getUTCFullYear();
                return new Date(Date.UTC(year, month, day));
            };
        UTCDateAdapter.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        UTCDateAdapter.ctorParameters = function () {
            return [
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [i0.LOCALE_ID,] }] }
            ];
        };
        return UTCDateAdapter;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} Cmp
     * @param {?} inputs
     * @return {?}
     */
    function proxyInputs(Cmp, inputs) {
        /** @type {?} */
        var Prototype = Cmp.prototype;
        inputs.forEach(function (item) {
            Object.defineProperty(Prototype, item, {
                get: /**
                 * @return {?}
                 */ function () { return this.el[item]; },
                set: /**
                 * @param {?} val
                 * @return {?}
                 */ function (val) { this.el[item] = val; },
            });
        });
    }
    /**
     * @param {?} Cmp
     * @param {?} methods
     * @return {?}
     */
    function proxyMethods(Cmp, methods) {
        /** @type {?} */
        var Prototype = Cmp.prototype;
        methods.forEach(function (methodName) {
            Prototype[methodName] = function () {
                /** @type {?} */
                var args = arguments;
                return this.el.componentOnReady().then(function (el) { return el[methodName].apply(el, args); });
            };
        });
    }
    /**
     * @param {?} instance
     * @param {?} el
     * @param {?} events
     * @return {?}
     */
    function proxyOutputs(instance, el, events) {
        events.forEach(function (eventName) { return instance[eventName] = rxjs.fromEvent(el, eventName); });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AnjAlert = /** @class */ (function () {
        function AnjAlert(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjAlertWillDismiss']);
        }
        AnjAlert.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-alert', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['dismissible', 'context'] }] }
        ];
        /** @nocollapse */
        AnjAlert.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjAlert;
    }());
    proxyInputs(AnjAlert, ['dismissible', 'context']);
    var AnjButton = /** @class */ (function () {
        function AnjButton(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjBlur', 'anjFocus']);
        }
        AnjButton.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-button', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['active', 'context', 'disabled', 'href', 'inverse', 'size', 'type'] }] }
        ];
        /** @nocollapse */
        AnjButton.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjButton;
    }());
    proxyInputs(AnjButton, ['active', 'context', 'disabled', 'href', 'inverse', 'size', 'type']);
    var AnjButtonClear = /** @class */ (function () {
        function AnjButtonClear(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjButtonClear.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-button-clear', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjButtonClear.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjButtonClear;
    }());
    var AnjButtonClose = /** @class */ (function () {
        function AnjButtonClose(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjButtonClose.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-button-close', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjButtonClose.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjButtonClose;
    }());
    var AnjButtonGroup = /** @class */ (function () {
        function AnjButtonGroup(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjButtonGroup.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-button-group', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['align', 'concat'] }] }
        ];
        /** @nocollapse */
        AnjButtonGroup.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjButtonGroup;
    }());
    proxyInputs(AnjButtonGroup, ['align', 'concat']);
    var AnjCard = /** @class */ (function () {
        function AnjCard(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjCard.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-card', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['size'] }] }
        ];
        /** @nocollapse */
        AnjCard.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjCard;
    }());
    proxyInputs(AnjCard, ['size']);
    var AnjCardBody = /** @class */ (function () {
        function AnjCardBody(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjCardBody.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-card-body', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjCardBody.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjCardBody;
    }());
    var AnjCardDeck = /** @class */ (function () {
        function AnjCardDeck(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjCardDeck.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-card-deck', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjCardDeck.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjCardDeck;
    }());
    var AnjCardFooter = /** @class */ (function () {
        function AnjCardFooter(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjCardFooter.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-card-footer', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjCardFooter.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjCardFooter;
    }());
    var AnjCardHeader = /** @class */ (function () {
        function AnjCardHeader(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjCardHeader.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-card-header', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjCardHeader.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjCardHeader;
    }());
    var AnjCheckbox = /** @class */ (function () {
        function AnjCheckbox(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjBlur', 'anjChange']);
        }
        AnjCheckbox.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-checkbox', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['checked', 'disabled', 'invalid', 'indeterminate', 'name', 'required', 'stacked', 'solo', 'value'] }] }
        ];
        /** @nocollapse */
        AnjCheckbox.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjCheckbox;
    }());
    proxyMethods(AnjCheckbox, ['checkValidity']);
    proxyInputs(AnjCheckbox, ['checked', 'disabled', 'invalid', 'indeterminate', 'name', 'required', 'stacked', 'solo', 'value']);
    var AnjCheckboxGroup = /** @class */ (function () {
        function AnjCheckboxGroup(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjCheckboxGroup.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-checkbox-group', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjCheckboxGroup.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjCheckboxGroup;
    }());
    var AnjColumn = /** @class */ (function () {
        function AnjColumn(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjColumnChange']);
        }
        AnjColumn.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-column', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['caption', 'cellFormatter', 'cellRenderer', 'cellTemplate', 'editable', 'editRenderer', 'field', 'headerFormatter', 'headerRenderer', 'internal', 'name', 'pinnable', 'pinned', 'orderable', 'overflow', 'span', 'sizable', 'sortable', 'sortIndex', 'sortOrder', 'width', 'visible'] }] }
        ];
        /** @nocollapse */
        AnjColumn.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjColumn;
    }());
    proxyMethods(AnjColumn, ['contextMenu', 'setOffset', 'setWidth', 'table', 'initCell']);
    proxyInputs(AnjColumn, ['caption', 'cellFormatter', 'cellRenderer', 'cellTemplate', 'editable', 'editRenderer', 'field', 'headerFormatter', 'headerRenderer', 'internal', 'name', 'pinnable', 'pinned', 'orderable', 'overflow', 'span', 'sizable', 'sortable', 'sortIndex', 'sortOrder', 'width', 'visible']);
    var AnjColumnPinner = /** @class */ (function () {
        function AnjColumnPinner(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjColumnPinner.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-column-pinner', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['enabled', 'disallow'] }] }
        ];
        /** @nocollapse */
        AnjColumnPinner.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjColumnPinner;
    }());
    proxyInputs(AnjColumnPinner, ['enabled', 'disallow']);
    var AnjColumnSizer = /** @class */ (function () {
        function AnjColumnSizer(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjResizeStart', 'anjResizeEnd']);
        }
        AnjColumnSizer.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-column-sizer', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjColumnSizer.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjColumnSizer;
    }());
    var AnjContextMenu = /** @class */ (function () {
        function AnjContextMenu(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjContextSelection']);
        }
        AnjContextMenu.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-context-menu', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['attach', 'loader'] }] }
        ];
        /** @nocollapse */
        AnjContextMenu.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjContextMenu;
    }());
    proxyMethods(AnjContextMenu, ['open', 'close']);
    proxyInputs(AnjContextMenu, ['attach', 'loader']);
    var AnjContextMenuItem = /** @class */ (function () {
        function AnjContextMenuItem(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjContextMenuItem.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-context-menu-item', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['action', 'disabled'] }] }
        ];
        /** @nocollapse */
        AnjContextMenuItem.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjContextMenuItem;
    }());
    proxyInputs(AnjContextMenuItem, ['action', 'disabled']);
    var AnjDatePicker = /** @class */ (function () {
        function AnjDatePicker(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjCalendarSelection']);
        }
        AnjDatePicker.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-date-picker', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['format', 'adapter', 'id', 'max', 'min', 'placement'] }] }
        ];
        /** @nocollapse */
        AnjDatePicker.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjDatePicker;
    }());
    proxyMethods(AnjDatePicker, ['open', 'close']);
    proxyInputs(AnjDatePicker, ['format', 'adapter', 'id', 'max', 'min', 'placement']);
    var AnjDatePickerDay = /** @class */ (function () {
        function AnjDatePickerDay(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjDatePickerDay.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-date-picker-day', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['adapter', 'date', 'day', 'month', 'rangeParams'] }] }
        ];
        /** @nocollapse */
        AnjDatePickerDay.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjDatePickerDay;
    }());
    proxyInputs(AnjDatePickerDay, ['adapter', 'date', 'day', 'month', 'rangeParams']);
    var AnjDatePickerMonth = /** @class */ (function () {
        function AnjDatePickerMonth(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjDatePickerMonth.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-date-picker-month', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['month', 'selected'] }] }
        ];
        /** @nocollapse */
        AnjDatePickerMonth.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjDatePickerMonth;
    }());
    proxyInputs(AnjDatePickerMonth, ['month', 'selected']);
    var AnjDatePickerMonthView = /** @class */ (function () {
        function AnjDatePickerMonthView(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjToggleMonthMode', 'anjMonthUpdated', 'anjMouseOut', 'anjMouseOver', 'anjDaySelected']);
        }
        AnjDatePickerMonthView.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-date-picker-month-view', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['package', 'rangeParams'] }] }
        ];
        /** @nocollapse */
        AnjDatePickerMonthView.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjDatePickerMonthView;
    }());
    proxyInputs(AnjDatePickerMonthView, ['package', 'rangeParams']);
    var AnjDatePickerToggle = /** @class */ (function () {
        function AnjDatePickerToggle(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjDatePickerToggle.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-date-picker-toggle', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjDatePickerToggle.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjDatePickerToggle;
    }());
    var AnjDatePickerYearView = /** @class */ (function () {
        function AnjDatePickerYearView(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjToggleMonthMode', 'anjMonthChanged', 'anjYearChanged']);
        }
        AnjDatePickerYearView.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-date-picker-year-view', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['package'] }] }
        ];
        /** @nocollapse */
        AnjDatePickerYearView.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjDatePickerYearView;
    }());
    proxyInputs(AnjDatePickerYearView, ['package']);
    var AnjDrawer = /** @class */ (function () {
        function AnjDrawer(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjDrawerChange']);
        }
        AnjDrawer.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-drawer', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjDrawer.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjDrawer;
    }());
    proxyMethods(AnjDrawer, ['close', 'open', 'toggle']);
    var AnjDrawerContainer = /** @class */ (function () {
        function AnjDrawerContainer(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjDrawerContainer.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-drawer-container', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjDrawerContainer.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjDrawerContainer;
    }());
    var AnjDropdown = /** @class */ (function () {
        function AnjDropdown(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjDropdown.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-dropdown', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['placement'] }] }
        ];
        /** @nocollapse */
        AnjDropdown.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjDropdown;
    }());
    proxyMethods(AnjDropdown, ['close', 'open']);
    proxyInputs(AnjDropdown, ['placement']);
    var AnjDropdownItem = /** @class */ (function () {
        function AnjDropdownItem(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjBlur']);
        }
        AnjDropdownItem.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-dropdown-item', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['disabled'] }] }
        ];
        /** @nocollapse */
        AnjDropdownItem.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjDropdownItem;
    }());
    proxyInputs(AnjDropdownItem, ['disabled']);
    var AnjEditing = /** @class */ (function () {
        function AnjEditing(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjEditing.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-editing', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['creating', 'deleting', 'mode', 'updating'] }] }
        ];
        /** @nocollapse */
        AnjEditing.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjEditing;
    }());
    proxyInputs(AnjEditing, ['creating', 'deleting', 'mode', 'updating']);
    var AnjFilter = /** @class */ (function () {
        function AnjFilter(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjFilter.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-filter', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['name', 'placeholder'] }] }
        ];
        /** @nocollapse */
        AnjFilter.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjFilter;
    }());
    proxyInputs(AnjFilter, ['name', 'placeholder']);
    var AnjFormError = /** @class */ (function () {
        function AnjFormError(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjFormError.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-form-error', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjFormError.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjFormError;
    }());
    var AnjFormGroup = /** @class */ (function () {
        function AnjFormGroup(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjFormGroup.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-form-group', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjFormGroup.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjFormGroup;
    }());
    var AnjFormHelper = /** @class */ (function () {
        function AnjFormHelper(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjFormHelper.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-form-helper', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjFormHelper.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjFormHelper;
    }());
    var AnjHeadline = /** @class */ (function () {
        function AnjHeadline(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjHeadline.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-headline', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['align'] }] }
        ];
        /** @nocollapse */
        AnjHeadline.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjHeadline;
    }());
    proxyInputs(AnjHeadline, ['align']);
    var AnjIconOpener = /** @class */ (function () {
        function AnjIconOpener(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjIconOpener.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-icon-opener', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjIconOpener.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjIconOpener;
    }());
    var AnjInput = /** @class */ (function () {
        function AnjInput(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjInvalid', 'anjInput', 'anjChange', 'anjBlur', 'anjFocus', 'anjControlDidLoad', 'anjControlDidUnload']);
        }
        AnjInput.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-input', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['attrs', 'autocomplete', 'autocorrect', 'autofocus', 'clearable', 'debounce', 'disabled', 'id', 'inputmode', 'invalid', 'labelId', 'max', 'maxlength', 'min', 'minlength', 'multiple', 'name', 'pattern', 'placeholder', 'readonly', 'required', 'spellcheck', 'step', 'size', 'type', 'value'] }] }
        ];
        /** @nocollapse */
        AnjInput.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjInput;
    }());
    proxyMethods(AnjInput, ['setFocus', 'setBlur', 'checkValidity']);
    proxyInputs(AnjInput, ['attrs', 'autocomplete', 'autocorrect', 'autofocus', 'clearable', 'debounce', 'disabled', 'id', 'inputmode', 'invalid', 'labelId', 'max', 'maxlength', 'min', 'minlength', 'multiple', 'name', 'pattern', 'placeholder', 'readonly', 'required', 'spellcheck', 'step', 'size', 'type', 'value']);
    var AnjInputPrefix = /** @class */ (function () {
        function AnjInputPrefix(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjInputPrefix.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-input-prefix', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['icon'] }] }
        ];
        /** @nocollapse */
        AnjInputPrefix.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjInputPrefix;
    }());
    proxyInputs(AnjInputPrefix, ['icon']);
    var AnjLabel = /** @class */ (function () {
        function AnjLabel(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjLabelDidLoad']);
        }
        AnjLabel.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-label', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['for', 'id'] }] }
        ];
        /** @nocollapse */
        AnjLabel.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjLabel;
    }());
    proxyInputs(AnjLabel, ['for', 'id']);
    var AnjModal = /** @class */ (function () {
        function AnjModal(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjModal.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-modal', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['closeOn', 'size'] }] }
        ];
        /** @nocollapse */
        AnjModal.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjModal;
    }());
    proxyMethods(AnjModal, ['open', 'close']);
    proxyInputs(AnjModal, ['closeOn', 'size']);
    var AnjModalBody = /** @class */ (function () {
        function AnjModalBody(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjModalBody.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-modal-body', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjModalBody.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjModalBody;
    }());
    var AnjModalFooter = /** @class */ (function () {
        function AnjModalFooter(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjModalFooter.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-modal-footer', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjModalFooter.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjModalFooter;
    }());
    var AnjModalHeader = /** @class */ (function () {
        function AnjModalHeader(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjModalHeader.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-modal-header', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjModalHeader.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjModalHeader;
    }());
    var AnjNumberStepper = /** @class */ (function () {
        function AnjNumberStepper(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjNumberStepper.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-number-stepper', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjNumberStepper.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjNumberStepper;
    }());
    var AnjOptgroup = /** @class */ (function () {
        function AnjOptgroup(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjOptgroup.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-optgroup', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['label', 'sticky'] }] }
        ];
        /** @nocollapse */
        AnjOptgroup.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjOptgroup;
    }());
    proxyInputs(AnjOptgroup, ['label', 'sticky']);
    var AnjOption = /** @class */ (function () {
        function AnjOption(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjOptionDidLoad', 'anjOptionDidUnload', 'anjSelect']);
        }
        AnjOption.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-option', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['disabled', 'selected', 'value'] }] }
        ];
        /** @nocollapse */
        AnjOption.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjOption;
    }());
    proxyMethods(AnjOption, ['select']);
    proxyInputs(AnjOption, ['disabled', 'selected', 'value']);
    var AnjPager = /** @class */ (function () {
        function AnjPager(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjPagerDidLoad', 'anjPage']);
        }
        AnjPager.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-pager', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['firstLast', 'info', 'page', 'range', 'size', 'sizes', 'total'] }] }
        ];
        /** @nocollapse */
        AnjPager.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjPager;
    }());
    proxyInputs(AnjPager, ['firstLast', 'info', 'page', 'range', 'size', 'sizes', 'total']);
    var AnjPopover = /** @class */ (function () {
        function AnjPopover(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjPopover.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-popover', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['arrow', 'placement'] }] }
        ];
        /** @nocollapse */
        AnjPopover.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjPopover;
    }());
    proxyMethods(AnjPopover, ['display', 'hide', 'toggle']);
    proxyInputs(AnjPopover, ['arrow', 'placement']);
    var AnjPopoverHeader = /** @class */ (function () {
        function AnjPopoverHeader(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjPopoverHeader.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-popover-header', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjPopoverHeader.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjPopoverHeader;
    }());
    var AnjRadio = /** @class */ (function () {
        function AnjRadio(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjBlur', 'anjRadioDidLoad', 'anjRadioDidUnload', 'anjSelect', 'anjInvalid']);
        }
        AnjRadio.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-radio', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['checked', 'disabled', 'invalid', 'name', 'required', 'stacked', 'value'] }] }
        ];
        /** @nocollapse */
        AnjRadio.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjRadio;
    }());
    proxyMethods(AnjRadio, ['checkValidity']);
    proxyInputs(AnjRadio, ['checked', 'disabled', 'invalid', 'name', 'required', 'stacked', 'value']);
    var AnjRadioGroup = /** @class */ (function () {
        function AnjRadioGroup(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjChange']);
        }
        AnjRadioGroup.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-radio-group', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['disabled', 'invalid', 'name', 'required', 'value'] }] }
        ];
        /** @nocollapse */
        AnjRadioGroup.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjRadioGroup;
    }());
    proxyMethods(AnjRadioGroup, ['checkValidity']);
    proxyInputs(AnjRadioGroup, ['disabled', 'invalid', 'name', 'required', 'value']);
    var AnjRowActions = /** @class */ (function () {
        function AnjRowActions(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjRowActions.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-row-actions', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['formatter', 'renderer', 'template'] }] }
        ];
        /** @nocollapse */
        AnjRowActions.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjRowActions;
    }());
    proxyInputs(AnjRowActions, ['formatter', 'renderer', 'template']);
    var AnjRowSelection = /** @class */ (function () {
        function AnjRowSelection(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjRowSelectionDidLoad']);
        }
        AnjRowSelection.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-row-selection', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['formatter', 'labelFormatter', 'template', 'renderer', 'mode'] }] }
        ];
        /** @nocollapse */
        AnjRowSelection.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjRowSelection;
    }());
    proxyInputs(AnjRowSelection, ['formatter', 'labelFormatter', 'template', 'renderer', 'mode']);
    var AnjSelect = /** @class */ (function () {
        function AnjSelect(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjBlur', 'anjChange', 'anjFocus', 'anjInvalid']);
        }
        AnjSelect.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-select', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['disabled', 'id', 'invalid', 'labelId', 'multiple', 'name', 'placeholder', 'required', 'value'] }] }
        ];
        /** @nocollapse */
        AnjSelect.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjSelect;
    }());
    proxyMethods(AnjSelect, ['checkValidity']);
    proxyInputs(AnjSelect, ['disabled', 'id', 'invalid', 'labelId', 'multiple', 'name', 'placeholder', 'required', 'value']);
    var AnjSpinner = /** @class */ (function () {
        function AnjSpinner(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjSpinner.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-spinner', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['fixed', 'size'] }] }
        ];
        /** @nocollapse */
        AnjSpinner.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjSpinner;
    }());
    proxyInputs(AnjSpinner, ['fixed', 'size']);
    var AnjStateStore = /** @class */ (function () {
        function AnjStateStore(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjStateStoreDidLoad']);
        }
        AnjStateStore.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-state-store', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['key', 'type'] }] }
        ];
        /** @nocollapse */
        AnjStateStore.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjStateStore;
    }());
    proxyMethods(AnjStateStore, ['get', 'set', 'clear']);
    proxyInputs(AnjStateStore, ['key', 'type']);
    var AnjTableMessage = /** @class */ (function () {
        function AnjTableMessage(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjTableMessage.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-table-message', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjTableMessage.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjTableMessage;
    }());
    var AnjText = /** @class */ (function () {
        function AnjText(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjText.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-text', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjText.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjText;
    }());
    var AnjTextarea = /** @class */ (function () {
        function AnjTextarea(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjInvalid', 'anjInput', 'anjChange', 'anjBlur', 'anjFocus', 'anjInputDidLoad', 'anjInputDidUnload']);
        }
        AnjTextarea.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-textarea', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['id', 'autofocus', 'debounce', 'disabled', 'invalid', 'maxlength', 'minlength', 'name', 'placeholder', 'readonly', 'required', 'spellcheck', 'cols', 'rows', 'wrap', 'value'] }] }
        ];
        /** @nocollapse */
        AnjTextarea.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjTextarea;
    }());
    proxyMethods(AnjTextarea, ['checkValidity']);
    proxyInputs(AnjTextarea, ['id', 'autofocus', 'debounce', 'disabled', 'invalid', 'maxlength', 'minlength', 'name', 'placeholder', 'readonly', 'required', 'spellcheck', 'cols', 'rows', 'wrap', 'value']);
    var AnjTimePicker = /** @class */ (function () {
        function AnjTimePicker(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjTimeChanged']);
        }
        AnjTimePicker.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-time-picker', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['id', 'locale', 'meridiem', 'placement', 'timezone', 'value'] }] }
        ];
        /** @nocollapse */
        AnjTimePicker.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjTimePicker;
    }());
    proxyMethods(AnjTimePicker, ['open', 'close']);
    proxyInputs(AnjTimePicker, ['id', 'locale', 'meridiem', 'placement', 'timezone', 'value']);
    var AnjTimePickerInput = /** @class */ (function () {
        function AnjTimePickerInput(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjHourChanged', 'anjMinuteChanged']);
        }
        AnjTimePickerInput.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-time-picker-input', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['minutes', 'strategy', 'value'] }] }
        ];
        /** @nocollapse */
        AnjTimePickerInput.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjTimePickerInput;
    }());
    proxyMethods(AnjTimePickerInput, ['focusNativeInput']);
    proxyInputs(AnjTimePickerInput, ['minutes', 'strategy', 'value']);
    var AnjTimePickerToggle = /** @class */ (function () {
        function AnjTimePickerToggle(c, r) {
            c.detach();
            this.el = r.nativeElement;
        }
        AnjTimePickerToggle.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-time-picker-toggle', changeDetection: 0, template: '<ng-content></ng-content>' }] }
        ];
        /** @nocollapse */
        AnjTimePickerToggle.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjTimePickerToggle;
    }());
    var AnjToggle = /** @class */ (function () {
        function AnjToggle(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjBlur', 'anjChange']);
        }
        AnjToggle.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-toggle', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['checked', 'disabled', 'invalid', 'name', 'required', 'stacked', 'value'] }] }
        ];
        /** @nocollapse */
        AnjToggle.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjToggle;
    }());
    proxyMethods(AnjToggle, ['checkValidity']);
    proxyInputs(AnjToggle, ['checked', 'disabled', 'invalid', 'name', 'required', 'stacked', 'value']);
    var AnjTypeAhead = /** @class */ (function () {
        function AnjTypeAhead(c, r) {
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ['anjChange', 'anjInvalid', 'anjQuery']);
        }
        AnjTypeAhead.decorators = [
            { type: i0.Component, args: [{ selector: 'anj-type-ahead', changeDetection: 0, template: '<ng-content></ng-content>', inputs: ['disabled', 'display', 'id', 'invalid', 'name', 'placeholder', 'readonly', 'required', 'value'] }] }
        ];
        /** @nocollapse */
        AnjTypeAhead.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ElementRef }
            ];
        };
        return AnjTypeAhead;
    }());
    proxyMethods(AnjTypeAhead, ['checkValidity']);
    proxyInputs(AnjTypeAhead, ['disabled', 'display', 'id', 'invalid', 'name', 'placeholder', 'readonly', 'required', 'value']);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DomOutlet = /** @class */ (function () {
        function DomOutlet(targetElement) {
            this.targetElement = targetElement;
        }
        Object.defineProperty(DomOutlet.prototype, "viewRef", {
            get: /**
             * @return {?}
             */ function () {
                return this._viewRef;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @template C
         * @param {?} template
         * @return {?}
         */
        DomOutlet.prototype.attachTemplate = /**
         * @template C
         * @param {?} template
         * @return {?}
         */
            function (template) {
                var _this = this;
                this._viewRef = template.viewContainerRef.createEmbeddedView(template.templateRef, template.context);
                this._viewRef.detectChanges();
                this._viewRef.rootNodes.forEach(function (rootNode) { return _this.targetElement.appendChild(rootNode); });
                this.setDisposeFn((function () {
                    /** @type {?} */
                    var index = template.viewContainerRef.indexOf(_this._viewRef);
                    if (index !== -1) {
                        template.viewContainerRef.remove(index);
                    }
                }));
                return this._viewRef;
            };
        /**
         * @param {?} context
         * @return {?}
         */
        DomOutlet.prototype.updateContext = /**
         * @param {?} context
         * @return {?}
         */
            function (context) {
                for (var prop in context) {
                    if (context.hasOwnProperty(prop)) {
                        this._viewRef.context[prop] = context[prop];
                    }
                }
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        DomOutlet.prototype.setDisposeFn = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.disposeFn = fn;
            };
        /**
         * @param {?} template
         * @return {?}
         */
        DomOutlet.prototype.attach = /**
         * @param {?} template
         * @return {?}
         */
            function (template) {
                this.template = template;
                return this.attachTemplate(template);
            };
        /**
         * @return {?}
         */
        DomOutlet.prototype.detach = /**
         * @return {?}
         */
            function () {
                if (this.template) {
                    this.template.setAttachedHost(null);
                    this.template = null;
                }
                this.invokeDisposeFn();
            };
        /**
         * @return {?}
         */
        DomOutlet.prototype.dispose = /**
         * @return {?}
         */
            function () {
                this.disposeFn();
                if (this.targetElement.parentNode != null) {
                    this.targetElement.parentNode.removeChild(this.targetElement);
                }
                return undefined;
            };
        /**
         * @private
         * @return {?}
         */
        DomOutlet.prototype.invokeDisposeFn = /**
         * @private
         * @return {?}
         */
            function () {
                if (this.disposeFn) {
                    this.disposeFn();
                    this.disposeFn = null;
                }
            };
        return DomOutlet;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Template = /** @class */ (function () {
        function Template(templateRef, viewContainerRef, context) {
            this.templateRef = templateRef;
            this.viewContainerRef = viewContainerRef;
            this.context = context;
        }
        Object.defineProperty(Template.prototype, "origin", {
            get: /**
             * @return {?}
             */ function () {
                return this.templateRef.elementRef;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} host
         * @param {?=} context
         * @return {?}
         */
        Template.prototype.attach = /**
         * @param {?} host
         * @param {?=} context
         * @return {?}
         */
            function (host, context) {
                if (context === void 0) {
                    context = this.context;
                }
                this.context = context;
                this.host = host;
                return host.attach(this);
            };
        /**
         * @return {?}
         */
        Template.prototype.detach = /**
         * @return {?}
         */
            function () {
                this.context = undefined;
                if (this.host) {
                    /** @type {?} */
                    var host = this.host;
                    this.host = null;
                    host.detach();
                }
            };
        /**
         * @param {?} host
         * @return {?}
         */
        Template.prototype.setAttachedHost = /**
         * @param {?} host
         * @return {?}
         */
            function (host) {
                this.host = host;
            };
        return Template;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TemplateDirective = /** @class */ (function () {
        function TemplateDirective(_template) {
            this._template = _template;
        }
        Object.defineProperty(TemplateDirective.prototype, "anjTemplateOf", {
            set: /**
             * @param {?} name
             * @return {?}
             */ function (name) {
                this._name = name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TemplateDirective.prototype, "name", {
            get: /**
             * @return {?}
             */ function () {
                return this._name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TemplateDirective.prototype, "template", {
            get: /**
             * @return {?}
             */ function () {
                return this._template;
            },
            enumerable: true,
            configurable: true
        });
        TemplateDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[anjTemplate]'
                    },] }
        ];
        /** @nocollapse */
        TemplateDirective.ctorParameters = function () {
            return [
                { type: i0.TemplateRef }
            ];
        };
        TemplateDirective.propDecorators = {
            anjTemplateOf: [{ type: i0.Input }]
        };
        return TemplateDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var inputs = [
        'columns',
        'columnWidth',
        'dataSource',
        'highlight',
        'dataSource',
        'editRowKeys',
        'height',
        'key',
        'name',
        'orderable',
        'renderer',
        'selectedRowKeys',
        'sizable',
        'sortKeys'
    ];
    /* tslint:disable:use-input-property-decorator */
    var AnjTable = /** @class */ (function (_super) {
        __extends(AnjTable, _super);
        function AnjTable(changeRef, viewRef, elRef) {
            var _this = _super.call(this) || this;
            _this.changeRef = changeRef;
            _this.viewRef = viewRef;
            _this.outletRows = [];
            _this.changeRef.detach();
            _this.el = elRef.nativeElement;
            _this.el.renderer = _this;
            proxyOutputs(_this, _this.el, ['anjPage', 'anjRowSelected', 'anjSort']);
            return _this;
        }
        /**
         * @private
         * @param {?} row
         * @param {?} index
         * @param {?=} column
         * @return {?}
         */
        AnjTable.rowContext = /**
         * @private
         * @param {?} row
         * @param {?} index
         * @param {?=} column
         * @return {?}
         */
            function (row, index, column) {
                return {
                    $implicit: row,
                    column: column,
                    index: index
                };
            };
        /**
         * @return {?}
         */
        AnjTable.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.outletRows.map(function (rowMap) {
                    for (var templateName in rowMap) {
                        if (rowMap[templateName]) {
                            rowMap[templateName] = rowMap[templateName].dispose();
                        }
                    }
                    return rowMap;
                });
            };
        /**
         * @param {?} cell
         * @param {?} offset
         * @param {?} col
         * @param {?} row
         * @param {?} rowIndex
         * @return {?}
         */
        AnjTable.prototype.cellTemplate = /**
         * @param {?} cell
         * @param {?} offset
         * @param {?} col
         * @param {?} row
         * @param {?} rowIndex
         * @return {?}
         */
            function (cell, offset, col, row, rowIndex) {
                this.fromTemplate(col.cellTemplate, cell, row, rowIndex);
                col.initCell(cell, offset);
            };
        /**
         * @param {?} templateName
         * @param {?} targetEl
         * @param {?} row
         * @param {?} rowIndex
         * @return {?}
         */
        AnjTable.prototype.fromTemplate = /**
         * @param {?} templateName
         * @param {?} targetEl
         * @param {?} row
         * @param {?} rowIndex
         * @return {?}
         */
            function (templateName, targetEl, row, rowIndex) {
                /** @type {?} */
                var rowMap = this.outletRows[rowIndex] || {};
                /** @type {?} */
                var outlet = rowMap[templateName];
                if (!targetEl) {
                    rowMap[templateName] = outlet.dispose();
                    return;
                }
                if (outlet) {
                    if (targetEl !== outlet.targetElement) {
                        this.updateOutlet(outlet, templateName, targetEl, AnjTable.rowContext(row, rowIndex));
                    }
                    else {
                        this.updateContext(outlet, AnjTable.rowContext(row, rowIndex));
                    }
                }
                else {
                    rowMap[templateName] = this.createOutlet(targetEl, templateName, AnjTable.rowContext(row, rowIndex));
                    this.outletRows[rowIndex] = rowMap;
                }
            };
        /**
         * @private
         * @param {?} target
         * @param {?} templateName
         * @param {?} context
         * @return {?}
         */
        AnjTable.prototype.createOutlet = /**
         * @private
         * @param {?} target
         * @param {?} templateName
         * @param {?} context
         * @return {?}
         */
            function (target, templateName, context) {
                /** @type {?} */
                var outlet = new DomOutlet(target);
                outlet.attach(this.createTemplate(templateName, context));
                return outlet;
            };
        /**
         * @private
         * @param {?} templateName
         * @param {?} context
         * @return {?}
         */
        AnjTable.prototype.createTemplate = /**
         * @private
         * @param {?} templateName
         * @param {?} context
         * @return {?}
         */
            function (templateName, context) {
                /** @type {?} */
                var templateRef = this.templates.find(function (t) { return t.name === templateName; }).template;
                return new Template(templateRef, this.viewRef, context);
            };
        /**
         * @private
         * @param {?} outlet
         * @param {?} context
         * @return {?}
         */
        AnjTable.prototype.updateContext = /**
         * @private
         * @param {?} outlet
         * @param {?} context
         * @return {?}
         */
            function (outlet, context) {
                outlet.updateContext(context);
                this.changeRef.markForCheck();
            };
        /**
         * @private
         * @param {?} outlet
         * @param {?} templateName
         * @param {?} targetEl
         * @param {?} context
         * @return {?}
         */
        AnjTable.prototype.updateOutlet = /**
         * @private
         * @param {?} outlet
         * @param {?} templateName
         * @param {?} targetEl
         * @param {?} context
         * @return {?}
         */
            function (outlet, templateName, targetEl, context) {
                outlet.targetElement = targetEl;
                outlet.detach();
                outlet.attach(this.createTemplate(templateName, context));
            };
        AnjTable.decorators = [
            { type: i0.Component, args: [{
                        selector: 'anj-table',
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        template: '<ng-content></ng-content>',
                        inputs: inputs
                    }] }
        ];
        /** @nocollapse */
        AnjTable.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ViewContainerRef },
                { type: i0.ElementRef }
            ];
        };
        AnjTable.propDecorators = {
            templates: [{ type: i0.ContentChildren, args: [TemplateDirective,] }]
        };
        return AnjTable;
    }(core.TableRenderer));
    proxyMethods(AnjTable, ['updateData']);
    proxyInputs(AnjTable, inputs);

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description A wrapper around the HTML 5 Drag API.
     */
    var DraggableDirective = /** @class */ (function () {
        function DraggableDirective(element) {
            var _this = this;
            this.element = element;
            this.dataFn = function () { return _this.getData(); };
            this.controller = new core.DragController(this.element.nativeElement, this.dataFn).connect();
        }
        /**
         * @private
         * @return {?}
         */
        DraggableDirective.prototype.getData = /**
         * @private
         * @return {?}
         */
            function () {
                return this.anjDraggable;
            };
        DraggableDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[anjDraggable]'
                    },] }
        ];
        /** @nocollapse */
        DraggableDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef }
            ];
        };
        DraggableDirective.propDecorators = {
            anjDraggable: [{ type: i0.Input }]
        };
        return DraggableDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description A wrapper around the HTML 5 Drop API.
     */
    var DroppableDirective = /** @class */ (function () {
        function DroppableDirective(element) {
            this.element = element;
            this.controller = new core.DropController(this.element.nativeElement).connect();
        }
        DroppableDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[anjDroppable]'
                    },] }
        ];
        /** @nocollapse */
        DroppableDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef }
            ];
        };
        return DroppableDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@internal
     */
    var ResizerDirective = /** @class */ (function () {
        function ResizerDirective(anjResizer, element) {
            this.anjResizer = anjResizer;
            this.element = element;
            this.resize = new i0.EventEmitter();
            this.resizeListener = this.handleResize.bind(this);
        }
        /**
         * @return {?}
         */
        ResizerDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                window.addEventListener('resize', this.resizeListener);
                this.parentElement = this.element.nativeElement.parentElement;
                this.getDimensions();
            };
        /**
         * @return {?}
         */
        ResizerDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                window.clearTimeout(this.resizeDebouncer);
                window.removeEventListener('resize', this.resizeListener);
            };
        /**
         * @return {?}
         */
        ResizerDirective.prototype.handleResize = /**
         * @return {?}
         */
            function () {
                var _this = this;
                window.clearTimeout(this.resizeDebouncer);
                this.resizeDebouncer = window.setTimeout(function () {
                    /** @type {?} */
                    var needsResize = _this.getDimensions();
                    if (needsResize) {
                        _this.resize.emit();
                    }
                }, this.anjResizer);
            };
        /**
         * @return {?}
         */
        ResizerDirective.prototype.getDimensions = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var parentWidth = this.parentElement.clientWidth;
                /** @type {?} */
                var parentHeight = this.parentElement.clientHeight;
                if (parentWidth === this.parentWidth && parentHeight === this.parentHeight) {
                    return false;
                }
                this.parentWidth = parentWidth;
                this.parentHeight = parentHeight;
                return true;
            };
        ResizerDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[anjResizer]'
                    },] }
        ];
        /** @nocollapse */
        ResizerDirective.ctorParameters = function () {
            return [
                { type: Number, decorators: [{ type: i0.Attribute, args: ['anjResizer',] }] },
                { type: i0.ElementRef }
            ];
        };
        ResizerDirective.propDecorators = {
            resize: [{ type: i0.Output }]
        };
        return ResizerDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var TransitionState = {
        Enter: 0,
        Leave: 1,
        EnterTo: 2,
        Inactive: 3,
    };
    TransitionState[TransitionState.Enter] = 'Enter';
    TransitionState[TransitionState.Leave] = 'Leave';
    TransitionState[TransitionState.EnterTo] = 'EnterTo';
    TransitionState[TransitionState.Inactive] = 'Inactive';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@experimental
     */
    var TransitionDirective = /** @class */ (function () {
        function TransitionDirective(renderer, element, mode, name) {
            this.renderer = renderer;
            this.element = element;
            this.mode = mode;
            this.name = name;
            this.state = TransitionState.EnterTo;
            this.end = new i0.EventEmitter();
            this.mode = this.mode ? this.mode : 'in-out';
            this.name = this.name ? this.name : 'transition';
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        TransitionDirective.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                this.endTransition();
                if (!changes.anjTransition.previousValue && !changes.anjTransition.currentValue && this.mode !== 'out') {
                    this.initEnter();
                }
                else if (!changes.anjTransition.previousValue && changes.anjTransition.currentValue) {
                    this.transitionIn();
                }
                else {
                    this.transitionOut();
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        TransitionDirective.prototype.handleTransition = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (event.target === this.element.nativeElement && TransitionDirective.supportedTransitions.indexOf(event.propertyName) > -1) {
                    event.stopPropagation();
                    this.end.emit(this.state);
                    if (this.state === TransitionState.Enter) {
                        this.endTransition();
                    }
                    else {
                        if (this.mode !== 'out' && this.anjTransition) {
                            this.transitionIn();
                        }
                        else {
                            this.endTransition();
                        }
                    }
                }
            };
        /**
         * @private
         * @return {?}
         */
        TransitionDirective.prototype.initEnter = /**
         * @private
         * @return {?}
         */
            function () {
                this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
            };
        /**
         * @private
         * @return {?}
         */
        TransitionDirective.prototype.transitionIn = /**
         * @private
         * @return {?}
         */
            function () {
                if (this.mode !== 'out') {
                    this.state = TransitionState.Enter;
                    this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
                    this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-leave");
                    this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-leave-active");
                    this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter-active");
                    this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter");
                }
                else {
                    this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
                    this.endTransition();
                }
            };
        /**
         * @private
         * @return {?}
         */
        TransitionDirective.prototype.transitionOut = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                this.state = TransitionState.Leave;
                if (this.mode !== 'in') {
                    this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-leave-active");
                    this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-leave");
                }
                else {
                    this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
                    this.state = TransitionState.EnterTo;
                    if (this.anjTransition) {
                        window.setTimeout(function () {
                            _this.transitionIn();
                        });
                    }
                }
            };
        /**
         * @private
         * @return {?}
         */
        TransitionDirective.prototype.endTransition = /**
         * @private
         * @return {?}
         */
            function () {
                this.state = TransitionState.Inactive;
                this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-enter-active");
                this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-leave-active");
                this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-enter");
                this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-leave");
                if (!this.anjTransition) {
                    this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
                }
            };
        TransitionDirective.supportedTransitions = ['opacity', 'transform'];
        TransitionDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[anjTransition]'
                    },] }
        ];
        /** @nocollapse */
        TransitionDirective.ctorParameters = function () {
            return [
                { type: i0.Renderer2 },
                { type: i0.ElementRef },
                { type: undefined, decorators: [{ type: i0.Attribute, args: ['mode',] }] },
                { type: String, decorators: [{ type: i0.Attribute, args: ['name',] }] }
            ];
        };
        TransitionDirective.propDecorators = {
            anjTransition: [{ type: i0.Input }],
            end: [{ type: i0.Output }],
            handleTransition: [{ type: i0.HostListener, args: ['transitiend', ['$event'],] }]
        };
        return TransitionDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ValueAccessor = /** @class */ (function () {
        function ValueAccessor(element, parentForm, parentGroup) {
            this.element = element;
            /**
             * Enable two-way binding
             */
            this.valueChange = new i0.EventEmitter();
            this.onChange = function () { };
            this.onTouched = function () { };
            this.parent = parentForm ? parentForm : parentGroup ? parentGroup : null;
            if (this.parent) {
                this.formSub = this.parent.ngSubmit.subscribe(this.checkValidity.bind(this));
            }
        }
        /**
         * @return {?}
         */
        ValueAccessor.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.formSub) {
                    this.formSub.unsubscribe();
                }
            };
        /**
         * @param {?} value
         * @return {?}
         */
        ValueAccessor.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                this.element.nativeElement.value = this.lastValue = value == null ? '' : value;
            };
        /**
         * @param {?} value
         * @return {?}
         */
        ValueAccessor.prototype.onChangeEvent = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                if (value !== this.lastValue) {
                    this.lastValue = value;
                    this.onChange(value);
                    this.valueChange.emit(value);
                }
            };
        /**
         * @return {?}
         */
        ValueAccessor.prototype.onAnjBlur = /**
         * @return {?}
         */
            function () {
                this.onTouched();
                this.checkValidity();
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        ValueAccessor.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onChange = fn;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        ValueAccessor.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onTouched = fn;
            };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        ValueAccessor.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
            function (isDisabled) {
                this.element.nativeElement.disabled = isDisabled;
            };
        /**
         * @return {?}
         */
        ValueAccessor.prototype.checkValidity = /**
         * @return {?}
         */
            function () {
                // TODO: this won't work for custom validators
                this.element.nativeElement.checkValidity();
            };
        ValueAccessor.propDecorators = {
            valueChange: [{ type: i0.Output }],
            onAnjBlur: [{ type: i0.HostListener, args: ['anjBlur',] }]
        };
        return ValueAccessor;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var BooleanValueDirective = /** @class */ (function (_super) {
        __extends(BooleanValueDirective, _super);
        function BooleanValueDirective(parentForm, parentFormGroup, element) {
            return _super.call(this, element, parentForm, parentFormGroup) || this;
        }
        /**
         * @param {?} value
         * @return {?}
         */
        BooleanValueDirective.prototype.onAnjChange = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                this.onChangeEvent(value);
                this.checkValidity();
            };
        BooleanValueDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'anj-checkbox, anj-toggle',
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: BooleanValueDirective,
                                multi: true
                            }
                        ]
                    },] }
        ];
        /** @nocollapse */
        BooleanValueDirective.ctorParameters = function () {
            return [
                { type: forms.NgForm, decorators: [{ type: i0.Optional }] },
                { type: forms.FormGroupDirective, decorators: [{ type: i0.Optional }] },
                { type: i0.ElementRef }
            ];
        };
        BooleanValueDirective.propDecorators = {
            onAnjChange: [{ type: i0.HostListener, args: ['anjChange', ['$event.target.checked'],] }]
        };
        return BooleanValueDirective;
    }(ValueAccessor));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@dynamic
     * @abstract
     */
    var AnjunaValidators = /** @class */ (function () {
        function AnjunaValidators() {
        }
        /**
         * @param {?} c
         * @return {?}
         */
        AnjunaValidators.date = /**
         * @param {?} c
         * @return {?}
         */
            function (c) {
                if (!c.value) {
                    return;
                }
                /** @type {?} */
                var isValid = true;
                // Handle obvious Invalid Date
                if (c.value.toString() === 'Invalid Date') {
                    isValid = false;
                    // Handle Moment Date
                }
                else if (typeof c.value._isValid === 'boolean') {
                    isValid = c.value._isValid;
                    // Handle Native Date
                }
                else {
                    isValid = !isNaN(new Date(c.value).getTime());
                }
                if (isValid || c.value === '') {
                    return null;
                }
                else {
                    return {
                        date: {
                            valid: false
                        }
                    };
                }
            };
        /**
         * @param {?} c
         * @return {?}
         */
        AnjunaValidators.requiredCheck = /**
         * @param {?} c
         * @return {?}
         */
            function (c) {
                if (c.value) {
                    return null;
                }
                else {
                    return {
                        required: {
                            valid: false
                        }
                    };
                }
            };
        /**
         * @param {?} c
         * @return {?}
         */
        AnjunaValidators.unique = /**
         * @param {?} c
         * @return {?}
         */
            function (c) {
                if (!c.value || !Array.isArray(c.value)) {
                    return;
                }
                /** @type {?} */
                var testArray = c.value.filter(Boolean);
                /** @type {?} */
                var isValid = testArray.length === Array.from(new Set(testArray)).length;
                if (isValid) {
                    return null;
                }
                else {
                    return {
                        unique: {
                            valid: false
                        }
                    };
                }
            };
        AnjunaValidators.minDate = function (min) {
            return function (c) {
                if (!c.value) {
                    return;
                }
                if (c.value < min) {
                    return {
                        min: {
                            valid: false
                        }
                    };
                }
                else {
                    return null;
                }
            };
        };
        AnjunaValidators.maxDate = function (max) {
            return function (c) {
                if (!c.value) {
                    return;
                }
                if (c.value > max) {
                    return {
                        max: {
                            valid: false
                        }
                    };
                }
                else {
                    return null;
                }
            };
        };
        return AnjunaValidators;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var DateValidatorDirective = /** @class */ (function () {
        function DateValidatorDirective() {
        }
        /**
         * @param {?} c
         * @return {?}
         */
        DateValidatorDirective.prototype.validate = /**
         * @param {?} c
         * @return {?}
         */
            function (c) {
                return AnjunaValidators.date(c);
            };
        DateValidatorDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[date][ngModel],[date][formControl]',
                        providers: [
                            { provide: forms.NG_VALIDATORS, useExisting: DateValidatorDirective, multi: true }
                        ]
                    },] }
        ];
        return DateValidatorDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DatePickerDirective = /** @class */ (function () {
        function DatePickerDirective(renderer, _element, changeRef, dateAdapter, parentForm, parentFormGroup, ngControl, _locale) {
            this.renderer = renderer;
            this._element = _element;
            this.changeRef = changeRef;
            this.dateAdapter = dateAdapter;
            this.ngControl = ngControl;
            this.onChange = function () {
            };
            this.onTouch = function () {
            };
            this.languageCode = (_locale) ? _locale.split('-')[0] : 'en';
            this.valueChange = new i0.EventEmitter();
            this.adapterStrategy = dateAdapter;
            if (this.ngControl) {
                this.ngControl.valueAccessor = this;
            }
            this.parent = parentForm ? parentForm : parentFormGroup ? parentFormGroup : null;
        }
        Object.defineProperty(DatePickerDirective.prototype, "value", {
            // Custom input to return inner value, but display masked value
            get: 
            // Custom input to return inner value, but display masked value
            /**
             * @return {?}
             */
            function () { return this.innerDateValue; },
            set: /**
             * @param {?} dateValue
             * @return {?}
             */ function (dateValue) {
                if (dateValue) {
                    this.innerDateValue = this.adapterStrategy.processDateInput(dateValue);
                    this.outerValue = this.adapterStrategy.prepDateStringOutput(dateValue);
                    this.changeRef.markForCheck();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DatePickerDirective.prototype, "adapter", {
            // AdapterStrategy will be set by the DateAdapter injected provider. This is for an optional override.
            set: 
            // AdapterStrategy will be set by the DateAdapter injected provider. This is for an optional override.
            /**
             * @param {?} adapter
             * @return {?}
             */
            function (adapter) {
                this.adapterStrategy = adapter;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        DatePickerDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                if (this.ngControl) {
                    this.value = this.ngControl.value;
                    this.changeRef.detectChanges();
                }
            };
        /**
         * @return {?}
         */
        DatePickerDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.listenerFn) {
                    this.listenerFn();
                }
            };
        // // Start: ControlValueAccessor requirements
        // // Start: ControlValueAccessor requirements
        /**
         * @param {?} newValue
         * @return {?}
         */
        DatePickerDirective.prototype.writeValue =
            // // Start: ControlValueAccessor requirements
            /**
             * @param {?} newValue
             * @return {?}
             */
            function (newValue) {
                this.value = newValue;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        DatePickerDirective.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onChange = fn;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        DatePickerDirective.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onTouch = fn;
            };
        // // End: ControlValueAccessor requirements
        // // End: ControlValueAccessor requirements
        /**
         * @param {?} event
         * @return {?}
         */
        DatePickerDirective.prototype.onInput =
            // // End: ControlValueAccessor requirements
            /**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                if (event.target.tagName === 'ANJ-INPUT') {
                    this.onTouch();
                    this.updateInnerValue(event.target.value);
                    this.valueChange.emit(this.innerDateValue);
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        DatePickerDirective.prototype.onCalendarSelect = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                this.onTouch();
                this.updateInnerValue(event.detail);
                this.valueChange.emit(this.innerDateValue);
            };
        /* Intercept and override native input validity, if ngControl has a validity issue */
        /* Intercept and override native input validity, if ngControl has a validity issue */
        /**
         * @param {?} event
         * @return {?}
         */
        DatePickerDirective.prototype.onAnjInvalid = /* Intercept and override native input validity, if ngControl has a validity issue */
            /**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                this.isInvalid();
                if (event.detail !== this.invalid && !event.detail) {
                    this._element.nativeElement
                        .dispatchEvent(new CustomEvent('anjInvalid', {
                        detail: this.invalid,
                        bubbles: true
                    }));
                    this.changeRef.markForCheck();
                }
            };
        /**
         * @private
         * @return {?}
         */
        DatePickerDirective.prototype.isInvalid = /**
         * @private
         * @return {?}
         */
            function () {
                if (!this.ngControl) {
                    return;
                }
                /** @type {?} */
                var isSubmitted = (this.parent && this.parent.submitted);
                this.invalid = this.ngControl.invalid && (this.ngControl.touched || isSubmitted);
            };
        // convert the masked value to storage value
        // convert the masked value to storage value
        /**
         * @private
         * @param {?} inputDate
         * @return {?}
         */
        DatePickerDirective.prototype.updateInnerValue =
            // convert the masked value to storage value
            /**
             * @private
             * @param {?} inputDate
             * @return {?}
             */
            function (inputDate) {
                this.innerDateValue = this.adapterStrategy.processDateInput(inputDate);
                this.propogateInnerValueChange();
            };
        /**
         * @private
         * @return {?}
         */
        DatePickerDirective.prototype.propogateInnerValueChange = /**
         * @private
         * @return {?}
         */
            function () {
                if (this.ngControl) {
                    this.ngControl.control.setValue(this.innerDateValue);
                }
                this.valueChange.emit(this.innerDateValue);
            };
        DatePickerDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'anj-input[anjDatePicker]',
                        exportAs: 'anjDatepickerInput'
                    },] }
        ];
        /** @nocollapse */
        DatePickerDirective.ctorParameters = function () {
            return [
                { type: i0.Renderer2 },
                { type: i0.ElementRef },
                { type: i0.ChangeDetectorRef },
                { type: DateAdapter },
                { type: forms.NgForm, decorators: [{ type: i0.Optional }] },
                { type: forms.FormGroupDirective, decorators: [{ type: i0.Optional }] },
                { type: forms.NgControl, decorators: [{ type: i0.Optional }, { type: i0.Self }] },
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [i0.LOCALE_ID,] }] }
            ];
        };
        DatePickerDirective.propDecorators = {
            value: [{ type: i0.Input }],
            adapter: [{ type: i0.Input }],
            outerValue: [{ type: i0.HostBinding, args: ['value',] }],
            invalid: [{ type: i0.HostBinding, args: ['attr.invalid',] }],
            languageCode: [{ type: i0.HostBinding, args: ['attr.language',] }],
            onInput: [{ type: i0.HostListener, args: ['anjBlur', ['$event'],] }],
            onCalendarSelect: [{ type: i0.HostListener, args: ['anjCalendarSelection', ['$event'],] }],
            onAnjInvalid: [{ type: i0.HostListener, args: ['anjInvalid', ['$event'],] }]
        };
        return DatePickerDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var TextValueDirective = /** @class */ (function (_super) {
        __extends(TextValueDirective, _super);
        function TextValueDirective(parentForm, parentFormGroup, element) {
            return _super.call(this, element, parentForm, parentFormGroup) || this;
        }
        /**
         * @param {?} value
         * @return {?}
         */
        TextValueDirective.prototype.onAnjChange = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                this.onChangeEvent(value);
                if (this.element.nativeElement.invalid) {
                    this.checkValidity();
                }
            };
        TextValueDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'anj-input, anj-textarea',
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: TextValueDirective,
                                multi: true
                            }
                        ]
                    },] }
        ];
        /** @nocollapse */
        TextValueDirective.ctorParameters = function () {
            return [
                { type: forms.NgForm, decorators: [{ type: i0.Optional }] },
                { type: forms.FormGroupDirective, decorators: [{ type: i0.Optional }] },
                { type: i0.ElementRef }
            ];
        };
        TextValueDirective.propDecorators = {
            onAnjChange: [{ type: i0.HostListener, args: ['anjChange', ['$event.detail.value'],] }]
        };
        return TextValueDirective;
    }(ValueAccessor));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?=} max
     * @return {?}
     */
    function validateMaxValueFactory(max) {
        if (max === void 0) {
            max = 0;
        }
        return function (c) {
            if (c.value === undefined || c.value === null) {
                return null;
            }
            if (Number(c.value) <= max) {
                return null;
            }
            else {
                return {
                    max: {
                        valid: false
                    }
                };
            }
        };
    }
    /* tslint:disable:directive-selector */
    var MaxValidatorDirective = /** @class */ (function () {
        function MaxValidatorDirective() {
        }
        Object.defineProperty(MaxValidatorDirective.prototype, "max", {
            get: /**
             * @return {?}
             */ function () { return this._max || 0; },
            set: /**
             * @param {?} max
             * @return {?}
             */ function (max) {
                this._max = Number(max);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MaxValidatorDirective.prototype.ngOnChanges = /**
         * @return {?}
         */
            function () {
                this.validator = validateMaxValueFactory(this.max);
            };
        /**
         * @param {?} c
         * @return {?}
         */
        MaxValidatorDirective.prototype.validate = /**
         * @param {?} c
         * @return {?}
         */
            function (c) {
                return this.validator(c);
            };
        MaxValidatorDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[max][ngModel]',
                        providers: [
                            { provide: forms.NG_VALIDATORS, useExisting: MaxValidatorDirective, multi: true }
                        ]
                    },] }
        ];
        MaxValidatorDirective.propDecorators = {
            _max: [{ type: i0.HostBinding, args: ['attr.max',] }],
            max: [{ type: i0.Input }]
        };
        return MaxValidatorDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?=} min
     * @return {?}
     */
    function validateMinValueFactory(min) {
        if (min === void 0) {
            min = 0;
        }
        return function (c) {
            if (c.value === undefined || c.value === null) {
                return null;
            }
            if (Number(c.value) >= min) {
                return null;
            }
            else {
                return {
                    min: {
                        valid: false
                    }
                };
            }
        };
    }
    /* tslint:disable:directive-selector */
    var MinValidatorDirective = /** @class */ (function () {
        function MinValidatorDirective() {
        }
        Object.defineProperty(MinValidatorDirective.prototype, "min", {
            get: /**
             * @return {?}
             */ function () { return this._min || 0; },
            set: /**
             * @param {?} min
             * @return {?}
             */ function (min) {
                this._min = Number(min);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MinValidatorDirective.prototype.ngOnChanges = /**
         * @return {?}
         */
            function () {
                this.validator = validateMinValueFactory(this.min);
            };
        /**
         * @param {?} c
         * @return {?}
         */
        MinValidatorDirective.prototype.validate = /**
         * @param {?} c
         * @return {?}
         */
            function (c) {
                return this.validator(c);
            };
        MinValidatorDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[min][ngModel]',
                        providers: [
                            { provide: forms.NG_VALIDATORS, useExisting: MinValidatorDirective, multi: true }
                        ]
                    },] }
        ];
        MinValidatorDirective.propDecorators = {
            _min: [{ type: i0.HostBinding, args: ['attr.min',] }],
            min: [{ type: i0.Input }]
        };
        return MinValidatorDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var RequiredCheckDirective = /** @class */ (function () {
        function RequiredCheckDirective() {
        }
        /**
         * @param {?} c
         * @return {?}
         */
        RequiredCheckDirective.prototype.validate = /**
         * @param {?} c
         * @return {?}
         */
            function (c) {
                return AnjunaValidators.requiredCheck(c);
            };
        RequiredCheckDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'anj-checkbox[required][ngModel], anj-toggle[required][ngModel]',
                        providers: [
                            { provide: forms.NG_VALIDATORS, useExisting: RequiredCheckDirective, multi: true }
                        ]
                    },] }
        ];
        return RequiredCheckDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var SelectValueDirective = /** @class */ (function (_super) {
        __extends(SelectValueDirective, _super);
        function SelectValueDirective(parentForm, parentFormGroup, element) {
            return _super.call(this, element, parentForm, parentFormGroup) || this;
        }
        /**
         * @param {?} target
         * @return {?}
         */
        SelectValueDirective.prototype.onAnjChange = /**
         * @param {?} target
         * @return {?}
         */
            function (target) {
                // ignore the input for type-aheads
                if (target.matches('anj-input')) {
                    return;
                }
                this.onChangeEvent(target.value);
                this.checkValidity();
            };
        SelectValueDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'anj-radio-group, anj-select, anj-type-ahead',
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: SelectValueDirective,
                                multi: true
                            }
                        ]
                    },] }
        ];
        /** @nocollapse */
        SelectValueDirective.ctorParameters = function () {
            return [
                { type: forms.NgForm, decorators: [{ type: i0.Optional }] },
                { type: forms.FormGroupDirective, decorators: [{ type: i0.Optional }] },
                { type: i0.ElementRef }
            ];
        };
        SelectValueDirective.propDecorators = {
            onAnjChange: [{ type: i0.HostListener, args: ['anjChange', ['$event.target'],] }]
        };
        return SelectValueDirective;
    }(ValueAccessor));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TimePickerDirective = /** @class */ (function () {
        function TimePickerDirective(_element, ngControl, _locale, _timezone, _meridiem) {
            this._element = _element;
            this.ngControl = ngControl;
            this._locale = _locale;
            this._timezone = _timezone;
            this._meridiem = _meridiem;
            this.onChange = function () {
            };
            this.onTouch = function () {
            };
            this.valueChange = new i0.EventEmitter();
            if (this.ngControl) {
                this.ngControl.valueAccessor = this;
            }
        }
        /**
         * @return {?}
         */
        TimePickerDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var picker = this._element.nativeElement.children[0];
                picker.setAttribute('locale', this._locale);
                picker.setAttribute('meridiem', this._meridiem);
                picker.setAttribute('timezone', this._timezone);
            };
        // // Start: ControlValueAccessor requirements
        // // Start: ControlValueAccessor requirements
        /**
         * @param {?} newValue
         * @return {?}
         */
        TimePickerDirective.prototype.writeValue =
            // // Start: ControlValueAccessor requirements
            /**
             * @param {?} newValue
             * @return {?}
             */
            function (newValue) {
                this.value = newValue;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        TimePickerDirective.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onChange = fn;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        TimePickerDirective.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onTouch = fn;
            };
        // // End: ControlValueAccessor requirements
        // // End: ControlValueAccessor requirements
        /**
         * @param {?} event
         * @return {?}
         */
        TimePickerDirective.prototype.onInput =
            // // End: ControlValueAccessor requirements
            /**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                this.value = event.detail;
                if (this.ngControl) {
                    this.ngControl.control.setValue(this.value);
                }
                this.valueChange.emit(this.value);
            };
        TimePickerDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'anj-input[anjTimePicker]',
                        exportAs: 'anjTimepickerInput'
                    },] }
        ];
        /** @nocollapse */
        TimePickerDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: forms.NgControl, decorators: [{ type: i0.Optional }, { type: i0.Self }] },
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [i0.LOCALE_ID,] }] },
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [TENANT_TIMEZONE_STRING,] }] },
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [TENANT_MERIDIEM,] }] }
            ];
        };
        TimePickerDirective.propDecorators = {
            value: [{ type: i0.HostBinding, args: ['value',] }],
            onInput: [{ type: i0.HostListener, args: ['anjTimeChanged', ['$event'],] }]
        };
        return TimePickerDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ZuoraDatePipe = /** @class */ (function () {
        function ZuoraDatePipe(datePipe) {
            this.datePipe = datePipe;
        }
        /**
         * @param {?} value
         * @param {?=} args
         * @return {?}
         */
        ZuoraDatePipe.prototype.transform = /**
         * @param {?} value
         * @param {?=} args
         * @return {?}
         */
            function (value, args) {
                try {
                    return this.datePipe.transform(value, 'shortDate');
                }
                catch (e) {
                    return;
                }
            };
        ZuoraDatePipe.decorators = [
            { type: i0.Pipe, args: [{
                        name: 'zuoraDate'
                    },] }
        ];
        /** @nocollapse */
        ZuoraDatePipe.ctorParameters = function () {
            return [
                { type: common.DatePipe }
            ];
        };
        return ZuoraDatePipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToastService = /** @class */ (function () {
        function ToastService() {
            this.controller = document.querySelector('anj-toast-controller') || ToastService.createController();
        }
        /**
         * @return {?}
         */
        ToastService.createController = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var controller = document.createElement('anj-toast-controller');
                document.body.appendChild(controller);
                return ( /** @type {?} */(controller));
            };
        /**
         * @return {?}
         */
        ToastService.prototype.dismissAll = /**
         * @return {?}
         */
            function () {
                this.controller.dismissAll();
            };
        /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        ToastService.prototype.error = /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
            function (message, header) {
                return this.controller.error(message, header);
            };
        /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        ToastService.prototype.message = /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
            function (message, header) {
                return this.controller.message(message, header);
            };
        /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        ToastService.prototype.success = /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
            function (message, header) {
                return this.controller.success(message, header);
            };
        /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        ToastService.prototype.warn = /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
            function (message, header) {
                return this.controller.warn(message, header);
            };
        ToastService.decorators = [
            { type: i0.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */
        ToastService.ctorParameters = function () { return []; };
        /** @nocollapse */ ToastService.ngInjectableDef = i0.defineInjectable({ factory: function ToastService_Factory() { return new ToastService(); }, token: ToastService, providedIn: "root" });
        return ToastService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LocalStorageService = /** @class */ (function (_super) {
        __extends(LocalStorageService, _super);
        function LocalStorageService() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        LocalStorageService.decorators = [
            { type: i0.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ LocalStorageService.ngInjectableDef = i0.defineInjectable({ factory: function LocalStorageService_Factory() { return new LocalStorageService(); }, token: LocalStorageService, providedIn: "root" });
        return LocalStorageService;
    }(core.LocalStorage));
    var SessionStorageService = /** @class */ (function (_super) {
        __extends(SessionStorageService, _super);
        function SessionStorageService() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SessionStorageService.decorators = [
            { type: i0.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ SessionStorageService.ngInjectableDef = i0.defineInjectable({ factory: function SessionStorageService_Factory() { return new SessionStorageService(); }, token: SessionStorageService, providedIn: "root" });
        return SessionStorageService;
    }(core.SessionStorage));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DIRECTIVES = [
        AnjAlert,
        AnjButton,
        AnjButtonClear,
        AnjButtonClose,
        AnjButtonGroup,
        AnjCard,
        AnjCardBody,
        AnjCardDeck,
        AnjCardFooter,
        AnjCardHeader,
        AnjCheckbox,
        AnjCheckboxGroup,
        AnjColumn,
        AnjColumnPinner,
        AnjColumnSizer,
        AnjContextMenu,
        AnjContextMenuItem,
        AnjDatePicker,
        AnjDatePickerDay,
        AnjDatePickerMonth,
        AnjDatePickerMonthView,
        AnjDatePickerToggle,
        AnjDatePickerYearView,
        AnjDrawer,
        AnjDrawerContainer,
        AnjDropdown,
        AnjDropdownItem,
        AnjEditing,
        AnjFilter,
        AnjFormError,
        AnjFormGroup,
        AnjFormHelper,
        AnjHeadline,
        AnjIconOpener,
        AnjInput,
        AnjInputPrefix,
        AnjLabel,
        AnjModal,
        AnjModalBody,
        AnjModalFooter,
        AnjModalHeader,
        AnjNumberStepper,
        AnjOptgroup,
        AnjOption,
        AnjPager,
        AnjPopover,
        AnjPopoverHeader,
        AnjRadio,
        AnjRadioGroup,
        AnjRowActions,
        AnjRowSelection,
        AnjSelect,
        AnjSpinner,
        AnjStateStore,
        AnjTableMessage,
        AnjText,
        AnjTextarea,
        AnjTimePicker,
        AnjTimePickerInput,
        AnjTimePickerToggle,
        AnjToggle,
        AnjTypeAhead
    ];

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DECLARATIONS = __spread([
        // Common
        DraggableDirective,
        DroppableDirective,
        ResizerDirective,
        TemplateDirective,
        TransitionDirective,
        ZuoraDatePipe,
        // Forms
        BooleanValueDirective,
        DatePickerDirective,
        DateValidatorDirective,
        MaxValidatorDirective,
        MinValidatorDirective,
        RequiredCheckDirective,
        SelectValueDirective,
        TextValueDirective,
        TimePickerDirective,
        // Tables
        AnjTable
    ], DIRECTIVES);
    var AnjunaCoreModule = /** @class */ (function () {
        function AnjunaCoreModule() {
        }
        AnjunaCoreModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: DECLARATIONS,
                        exports: DECLARATIONS,
                        providers: [
                            common.DatePipe,
                            {
                                provide: DateAdapter,
                                useClass: NativeDateAdapter,
                                deps: [i0.LOCALE_ID]
                            },
                            ZuoraDatePipe
                        ]
                    },] }
        ];
        return AnjunaCoreModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.getMomentDateAdapter = getMomentDateAdapter;
    exports.MomentDateAdapter = MomentDateAdapter;
    exports.UTCDateAdapter = UTCDateAdapter;
    exports.AnjAlert = AnjAlert;
    exports.AnjButton = AnjButton;
    exports.AnjButtonClear = AnjButtonClear;
    exports.AnjButtonClose = AnjButtonClose;
    exports.AnjButtonGroup = AnjButtonGroup;
    exports.AnjCard = AnjCard;
    exports.AnjCardBody = AnjCardBody;
    exports.AnjCardDeck = AnjCardDeck;
    exports.AnjCardFooter = AnjCardFooter;
    exports.AnjCardHeader = AnjCardHeader;
    exports.AnjCheckbox = AnjCheckbox;
    exports.AnjCheckboxGroup = AnjCheckboxGroup;
    exports.AnjColumn = AnjColumn;
    exports.AnjColumnPinner = AnjColumnPinner;
    exports.AnjColumnSizer = AnjColumnSizer;
    exports.AnjContextMenu = AnjContextMenu;
    exports.AnjContextMenuItem = AnjContextMenuItem;
    exports.AnjDatePicker = AnjDatePicker;
    exports.AnjDatePickerDay = AnjDatePickerDay;
    exports.AnjDatePickerMonth = AnjDatePickerMonth;
    exports.AnjDatePickerMonthView = AnjDatePickerMonthView;
    exports.AnjDatePickerToggle = AnjDatePickerToggle;
    exports.AnjDatePickerYearView = AnjDatePickerYearView;
    exports.AnjDrawer = AnjDrawer;
    exports.AnjDrawerContainer = AnjDrawerContainer;
    exports.AnjDropdown = AnjDropdown;
    exports.AnjDropdownItem = AnjDropdownItem;
    exports.AnjEditing = AnjEditing;
    exports.AnjFilter = AnjFilter;
    exports.AnjFormError = AnjFormError;
    exports.AnjFormGroup = AnjFormGroup;
    exports.AnjFormHelper = AnjFormHelper;
    exports.AnjHeadline = AnjHeadline;
    exports.AnjIconOpener = AnjIconOpener;
    exports.AnjInput = AnjInput;
    exports.AnjInputPrefix = AnjInputPrefix;
    exports.AnjLabel = AnjLabel;
    exports.AnjModal = AnjModal;
    exports.AnjModalBody = AnjModalBody;
    exports.AnjModalFooter = AnjModalFooter;
    exports.AnjModalHeader = AnjModalHeader;
    exports.AnjNumberStepper = AnjNumberStepper;
    exports.AnjOptgroup = AnjOptgroup;
    exports.AnjOption = AnjOption;
    exports.AnjPager = AnjPager;
    exports.AnjPopover = AnjPopover;
    exports.AnjPopoverHeader = AnjPopoverHeader;
    exports.AnjRadio = AnjRadio;
    exports.AnjRadioGroup = AnjRadioGroup;
    exports.AnjRowActions = AnjRowActions;
    exports.AnjRowSelection = AnjRowSelection;
    exports.AnjSelect = AnjSelect;
    exports.AnjSpinner = AnjSpinner;
    exports.AnjStateStore = AnjStateStore;
    exports.AnjTableMessage = AnjTableMessage;
    exports.AnjText = AnjText;
    exports.AnjTextarea = AnjTextarea;
    exports.AnjTimePicker = AnjTimePicker;
    exports.AnjTimePickerInput = AnjTimePickerInput;
    exports.AnjTimePickerToggle = AnjTimePickerToggle;
    exports.AnjToggle = AnjToggle;
    exports.AnjTypeAhead = AnjTypeAhead;
    exports.AnjTable = AnjTable;
    exports.DraggableDirective = DraggableDirective;
    exports.DroppableDirective = DroppableDirective;
    exports.ResizerDirective = ResizerDirective;
    exports.TemplateDirective = TemplateDirective;
    exports.TransitionDirective = TransitionDirective;
    exports.BooleanValueDirective = BooleanValueDirective;
    exports.DateValidatorDirective = DateValidatorDirective;
    exports.DatePickerDirective = DatePickerDirective;
    exports.TextValueDirective = TextValueDirective;
    exports.validateMaxValueFactory = validateMaxValueFactory;
    exports.MaxValidatorDirective = MaxValidatorDirective;
    exports.validateMinValueFactory = validateMinValueFactory;
    exports.MinValidatorDirective = MinValidatorDirective;
    exports.RequiredCheckDirective = RequiredCheckDirective;
    exports.SelectValueDirective = SelectValueDirective;
    exports.TimePickerDirective = TimePickerDirective;
    exports.TENANT_TIMEZONE_STRING = TENANT_TIMEZONE_STRING;
    exports.TENANT_MERIDIEM = TENANT_MERIDIEM;
    exports.TIMEZONE_OVERRIDE = TIMEZONE_OVERRIDE;
    exports.MOMENT = MOMENT;
    exports.AnjunaValidators = AnjunaValidators;
    exports.ZuoraDatePipe = ZuoraDatePipe;
    exports.ToastService = ToastService;
    exports.LocalStorageService = LocalStorageService;
    exports.SessionStorageService = SessionStorageService;
    exports.getWeekdays = getWeekdays;
    exports.getMonths = getMonths;
    exports.localize = localize;
    exports.parseInput = parseInput;
    exports.STANDARD_LOCALES = STANDARD_LOCALES;
    exports.DateAdapter = DateAdapter;
    exports.NativeDateAdapter = NativeDateAdapter;
    exports.TransitionState = TransitionState;
    exports.AnjunaCoreModule = AnjunaCoreModule;
    exports.ɵa = ValueAccessor;
    exports.ɵb = DIRECTIVES;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=anjuna-angular-core.umd.js.map