import { tick } from '@angular/core/testing';
import { Injectable } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormControlMock {
    /**
     * @param {?=} type
     */
    constructor(type = 'text') {
        this.nativeElement = document.createElement('input');
        this.nativeElement.setAttribute('type', type);
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 * @param {?} f
 * @param {?=} advanceBy
 * @return {?}
 */
function advance(f, advanceBy = 0) {
    tick(advanceBy);
    f.detectChanges();
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MockToast {
    /**
     * @param {?} message
     * @param {?} context
     * @param {?=} header
     */
    constructor(message, context, header) {
        this.message = message;
        this.context = context;
        this.header = header;
    }
    /**
     * @return {?}
     */
    dismiss() {
        return new Promise((resolve) => resolve());
    }
}
/**
 * \@dynamic
 * @type {?}
 */
const mockToastController = {
    dismissAll: () => { },
    error: (message, header) => {
        return (/** @type {?} */ (new MockToast(message, 'danger', header)));
    },
    message: (message, header) => {
        return (/** @type {?} */ (new MockToast(message, 'info', header)));
    },
    success: (message, header) => {
        return (/** @type {?} */ (new MockToast(message, 'success', header)));
    },
    warn: (message, header) => {
        return (/** @type {?} */ (new MockToast(message, 'success', header)));
    }
};
/**
 * \@dynamic
 */
class MockToastService {
    constructor() {
        this.controller = MockToastService.createController();
    }
    /**
     * @return {?}
     */
    static createController() {
        return (/** @type {?} */ (mockToastController));
    }
    /**
     * @return {?}
     */
    dismissAll() {
        this.controller.dismissAll();
    }
    /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    error(message, header) {
        return this.controller.error(message, header);
    }
    /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    message(message, header) {
        return this.controller.message(message, header);
    }
    /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    success(message, header) {
        return this.controller.success(message, header);
    }
    /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    warn(message, header) {
        return this.controller.warn(message, header);
    }
}
MockToastService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
MockToastService.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FormControlMock, advance, MockToast, mockToastController, MockToastService };

//# sourceMappingURL=anjuna-angular-core-testing.js.map